//--------------------------------------------------
//Headerfile: translator.cpp
//Beschreibung: Translator OOP
//Autor:  Harald Bucher, ITIV
//Erstellt: 20.06.2014
//Version: 1.1 (Bucher)
//--------------------------------------------------

#include "translator.h"
#include <string>
#include <stdlib.h>
#include <iostream>

using namespace std;

Translator::Translator(string _filename) {
    myDictionary = new Dictionary(_filename);
}

Translator::~Translator() {
    /*Beim Zerstren des Translators auch Speicher
    * des Dictionary wieder freigeben
    */
    delete myDictionary;
}

void Translator::menu() {
    char auswahl = 'a';
    do {
        cout << endl << "W\x94rterbuch" << endl;
        cout << "----------" << endl << endl;
        cout << "(S)uche \x9A \bbersetzung" << endl;
        cout << "(E)nde" << endl << endl;
        cout << "Ihre Wahl: ";
        cin >> auswahl;
        cin.ignore();
        switch (auswahl) {
        case 'S':
        case 's':
            search();
            system("pause");
            break;
        case 'e':
        case 'E': break;
        default:
            cout << "Keine g\x81ltige Eingabe!" << endl;
            system("pause");
        }
        system("cls");
    } while (auswahl != 'e' && auswahl != 'E');
}

void Translator::search() {
    string searchWord;
    bool wordFound = false;
    cout << "Bitte deutsches oder englisches Suchwort eingeben: ";
    getline(cin, searchWord);
    cin.sync();
    cout << endl;

    string germanTranslation = myDictionary->searchEnglish(searchWord);
    string englishTranslation = myDictionary->searchGerman(searchWord);

    if (germanTranslation != "not in map") {
        cout << "Die deutsche \x9A \bbersetzung lautet: " << germanTranslation << endl;
        wordFound = true;
    }

    if (englishTranslation != "not in map") {
        cout << "Die englische \x9A \bbersetzung lautet: " << englishTranslation << endl;
        wordFound = true;
    }

    if (!wordFound) {
        char add = 'a';
        string germanWord, englishWord;
        do {
            cout << "Begriff nicht im W\x94rterbuch! Hinzuf\x81gen? (y/n)";
            cin >> add;
            cin.ignore();
            cout << endl;
        } while ((add != 'y') && (add != 'n'));

        if (add == 'y') {
            cout << "Bitte das deutsche Wort eingeben: ";
            getline(cin, germanWord);
            cin.sync();
            cout << "Bitte das englische Wort eingeben: ";
            getline(cin, englishWord);
            cin.sync();
            myDictionary->add(germanWord, englishWord);
            cout << endl << "Neues Wortpaar hinzugef\x81gt" << endl;
        }
    }
}

void Translator::save() {
    myDictionary->saveToFile();
}
