#include <iostream>
#include <fstream>
#include <string>
#include <ctime>
#include "aufg_6.h"

using namespace std;

class MemoBlock {
private:
    string filename;
    inline void openError();
    inline void writeError();
    inline void readError();
    void schreiben();
    void lesen();
    void loeschen();

public:
    MemoBlock();
    ~MemoBlock();
    void setfilename(string _filename);
    void menu();
};

inline void MemoBlock::openError() {
    cerr << "Fehler beim Oeffnen der Datei " << filename << endl;
    exit(1);
}

inline void MemoBlock::writeError() {
    cerr << "Fehler beim Schreiben in die Datei " << filename << endl;
    exit(2);
}

inline void MemoBlock::readError() {
    cerr << "Fehler beim Lesen der Datei " << filename << endl;
    exit(3);
}

void MemoBlock::schreiben() {
    string line;
    char zeit[26];

    fstream memoFile(filename.c_str(), ios::out | ios::app);

    if (!memoFile) {
        openError();
    }

    time_t sec = time(NULL);
    ctime_s(zeit, 26, &sec);
    zeit[24] = '\0';

    cout << "Geben Sie Ihre Notiz ein:\n";
    getline(cin, line);

    if (!(memoFile << zeit << ": " << line << endl)) {
        writeError();
    }

    memoFile.close();
}

void MemoBlock::lesen() {
    string line;
    int number = 0;

    fstream memoFile(filename.c_str(), ios::in);

    if (!memoFile) {
        openError();
    }

    while (getline(memoFile, line)) {
        cout.width(5);
        cout << ++number << ": " << line << endl;
    }

    if (!memoFile.eof()) {
        readError();
    }

    memoFile.close();
}

void MemoBlock::loeschen() {
    fstream memoFile(filename.c_str(), ios::out);

    if (!memoFile) {
        openError();
    }

    memoFile.close();
}

MemoBlock::MemoBlock() {
}

MemoBlock::~MemoBlock() {
}

void MemoBlock::setfilename(string _filename) {
    filename = _filename;
}

void MemoBlock::menu() {
    char auswahl = 'a';

    do {
        cout << endl;
        cout << "Memoblock" << endl;
        cout << "---------" << endl << endl;
        cout << "(N)eues Memo hinzufuegen" << endl;
        cout << "(V)orhandene Memosausgeben" << endl;
        cout << "(L)oechen der Memodatei" << endl;
        cout << "(E)nde" << endl;
        cout << "bitte auswaehlen:";
        cin >> auswahl;
        cin.sync();
        cin.ignore();

        switch (auswahl) {
        case 'N':
        case 'n': schreiben(); break;
        case 'V':
        case 'v': lesen(); break;
        case 'L':
        case 'l': loeschen(); break;
        case 'e':
        case 'E': break;
        default: cout << "Keine gltige Eingabe!";
        }
    } while (auswahl != 'e' && auswahl != 'E');
}

void aufg_6_02(void) {

    MemoBlock Memo;

    Memo.setfilename("memo.txt");

    Memo.menu();
}
