//--------------------------------------------------
//Headerfile: main.cpp
//Beschreibung: Studentendatenbank OOP
//Autor:  Harald Bucher, Marc Weber, ITIV
//Erstellt: 20.05.2016
//Version: 1.1
//--------------------------------------------------

#include "Studentendatenbank\studentenverwaltung.h"
#include <limits>

void daten_hinzufuegen(Studentenverwaltung* database);
void daten_suchen(Studentenverwaltung* database);
void daten_loeschen(Studentenverwaltung* database);
void daten_ausgabe(Studentenverwaltung* database);

void aufg_6_03(void) {

    Studentenverwaltung* database = new Studentenverwaltung;

    int auswahl;

    do {
        cout << endl;
        cout << "Studentendatenbank" << endl;
        cout << "------------------" << endl << endl;
        cout << "(1) Eintrag hinzufuegen" << endl;
        cout << "(2) Eintrag suchen" << endl;
        cout << "(3) Eintrag loeschen" << endl;
        cout << "(4) Datenbank ausgeben" << endl;
        cout << "(5) Ende" << endl;
        cout << "Bitte auswaehlen: ";
        if (cin >> auswahl) {
            switch (auswahl) {
            case 1: daten_hinzufuegen(database); break;
            case 2: daten_suchen(database); break;
            case 3: daten_loeschen(database); break;
            case 4: daten_ausgabe(database); break;
            case 5: break;
            default: cout << "Ihre Eingabe ist falsch, die Option steht nicht zur Verfuegung" << endl;
            }
        }
        else {
            cout << "Sie haben keine Zahl eingegeben!" << endl;
        }
        cin.clear();
        cin.ignore(numeric_limits<streamsize>::max(), '\n');
    } while (auswahl != 5);

    delete database;
}

void daten_hinzufuegen(Studentenverwaltung* database) {
    string name;
    string vorname;
    int matrikelNr;
    double note;

    cout << endl << "Bitte die neuen Daten eingeben" << endl;
    cout << "Name: ";
    cin >> name;
    cout << "Vorname: ";
    cin >> vorname;
    cout << "Matrikelnummer: ";
    cin >> matrikelNr;
    cout << "Note: ";
    cin >> note;

    database->addStudent(vorname, name, matrikelNr, note);
}

void daten_suchen(Studentenverwaltung* database) {
    int matrikelNr;

    cout << "Bitte zu suchende Matrikelnummer eingeben: ";
    cin >> matrikelNr;

    list<Student>::iterator gesucht = database->findStudent(matrikelNr);
    database->printStudent(gesucht);
}

void daten_loeschen(Studentenverwaltung* database) {
    int matrikelNr;

    cout << "Bitte zu loeschende Matrikelnummer eingeben: ";
    cin >> matrikelNr;

    list<Student>::iterator gesucht = database->findStudent(matrikelNr);
    database->deleteStudent(gesucht);
}

void daten_ausgabe(Studentenverwaltung* database) {
    database->print();
}
